ALTER TABLE NMAPE
DROP CONSTRAINT PK_NMAPE;

ALTER TABLE NMAPE 
ADD ID_NMAPE NUMBER;

CREATE SEQUENCE NMAPE_SEQ MINVALUE 1 INCREMENT BY 1 START WITH 1 NOCACHE NOORDER  NOCYCLE;

UPDATE NMAPE 
SET ID_NMAPE = NMAPE_SEQ.NEXTVAL
WHERE ID_NMAPE IS NULL;

ALTER TABLE NMAPE
ADD CONSTRAINT NMAPE_PK PRIMARY KEY (ID_NMAPE);

CREATE OR REPLACE
TRIGGER NMAPE_TRG
BEFORE INSERT
ON NMAPE
REFERENCING NEW AS NEW OLD AS OLD
FOR EACH ROW
BEGIN
	IF (:NEW.ID_NMAPE IS NULL) THEN
          SELECT NMAPE_SEQ.NEXTVAL INTO :NEW.ID_NMAPE FROM DUAL;;
	END IF;;
END;;
;



ALTER TABLE MAPE 
ADD ID_MAPE NUMBER;

CREATE SEQUENCE MAPE_SEQ MINVALUE 1 INCREMENT BY 1 START WITH 1 NOCACHE NOORDER  NOCYCLE;

UPDATE MAPE 
SET ID_MAPE = MAPE_SEQ.NEXTVAL
WHERE ID_MAPE IS NULL;

ALTER TABLE MAPE
ADD CONSTRAINT MAPE_PK PRIMARY KEY (ID_MAPE);

CREATE OR REPLACE
TRIGGER MAPE_TRG
BEFORE INSERT
ON MAPE
REFERENCING NEW AS NEW OLD AS OLD
FOR EACH ROW
BEGIN
	IF (:NEW.ID_MAPE IS NULL) THEN
          SELECT MAPE_SEQ.NEXTVAL INTO :NEW.ID_MAPE FROM DUAL;;
	END IF;;
END;;
;


ALTER TABLE NMAPE
ADD NNLOCATION_ID NUMBER;

ALTER TABLE MAPE
ADD NNLOCATION_ID NUMBER;

ALTER TABLE MAPE
ADD ID_NMAPE NUMBER;

UPDATE MAPE M
SET M.ID_NMAPE = (SELECT N.ID_NMAPE FROM NMAPE N WHERE N.N_MAPE = M.N_MAPE);


CREATE OR REPLACE VIEW V_NMAPE AS (
  SELECT N.ID_NMAPE, N.ID_LASTNIKA, N.ID_PLOVILA, N.N_MAPE, N.NMAPLOK, N.NNLOCATION_ID,
  NMP.OPIS AS NMAPLOK_OPIS, NMP.INTERNI_OPIS AS NMAPLOK_INTERNI_OPIS, P.IME AS PLOVILA_IME, K.IME AS KUPCI_IME, K.PRIIMEK AS KUPCI_PRIIMEK
	FROM NMAPE N
  LEFT OUTER JOIN NMAPLOK NMP ON NMP.NMAPLOK = N.NMAPLOK
  LEFT OUTER JOIN PLOVILA P ON P.ID = N.ID_PLOVILA
  LEFT OUTER JOIN KUPCI K ON K.ID = N.ID_LASTNIKA
);


CREATE OR REPLACE VIEW V_MAPE AS (
  SELECT M.ID_MAPE, M.ID_LASTNIKA, M.ID_PLOVILA, M.DATUM, M.CAS, M.CODE, M.N_MAPE, M.NMAPLOK, M.MAPLOK, M.USER_KREIRANJA, M.NNLOCATION_ID, M.ID_NMAPE,
  NM.N_MAPE AS NMAPE_N_MAPE, NMP.OPIS AS NMAPLOK_OPIS, NMP.INTERNI_OPIS AS NMAPLOK_INTERNI_OPIS
	FROM MAPE M
  LEFT OUTER JOIN NMAPE NM ON NM.ID_NMAPE = M.ID_NMAPE
  LEFT OUTER JOIN NMAPLOK NMP ON NMP.NMAPLOK = M.NMAPLOK
);

insert into verzije_baza
(id, dt_vpis, verzija, ver_nr, opis) values (1267, SYSDATE, '5.5', 1187, 'Mape lokacija')
;
