CREATE TABLE REZERVAC_DETAIL_SVG (
  ID_REZERVAC_DETAIL NUMBER NOT NULL 
, TRANS_X NUMBER NOT NULL 
, TRANS_Y NUMBER NOT NULL 
, ROT_DEGREES NUMBER NOT NULL 
);

CREATE OR REPLACE VIEW V_REZERVAC AS (
SELECT R.ID, D.ID_REZERVAC_DETAIL, (CASE WHEN STATUS_REZERVAC=1 THEN 1 ELSE 0 END) AS PRISOTNO, D.DATUM_OD AS DATUM_REZERVACIJE, D.DATUM_DO, 
NP.OBJEKT AS NOBJEKT, NP.N_PRIVEZA AS PRIVEZ, D.ID_PRIVEZ, R.VRSTA, R.STATUS_REZERVAC, R.ID_LASTNIKA, R.ID_PLOVILA, 
(CASE WHEN R.ID_LASTNIKA IS NULL OR R.ID_LASTNIKA = 0 THEN R.NAZIV ELSE K.PRIIMEK END) AS NAZIV, 
(CASE WHEN R.ID_LASTNIKA IS NULL OR R.ID_LASTNIKA = 0 THEN R.PRIIMEK ELSE K.PRIIMEK END) AS PRIIMEK,
(CASE WHEN R.ID_LASTNIKA IS NULL OR R.ID_LASTNIKA = 0 THEN R.IME ELSE K.IME END) AS IME, K.SALDAKONTI_SIT,
(CASE WHEN R.ID_PLOVILA IS NULL OR R.ID_PLOVILA = 0 THEN R.PLOVILO ELSE P.IME END) AS PLOVILO, 
(CASE WHEN R.ID_PLOVILA IS NULL OR R.ID_PLOVILA = 0 THEN R.DOLZINA ELSE P.DOLZINA END) AS DOLZINA,
(CASE WHEN R.ID_PLOVILA IS NULL OR R.ID_PLOVILA = 0 THEN R.SIRINA ELSE P.SIRINA END) AS SIRINA,
(CASE WHEN R.ID_PLOVILA IS NULL OR R.ID_PLOVILA = 0 THEN R.GREZ ELSE P.GREZ END) AS GREZ,
(CASE WHEN R.ID_PLOVILA IS NULL OR R.ID_PLOVILA = 0 THEN 'J' ELSE P.NTIP END) AS NTIP
FROM REZERVAC R
JOIN REZERVAC_DETAIL D ON R.ID=D.ID_REZERVAC 
LEFT OUTER JOIN NNPRIVEZ NP ON D.ID_PRIVEZ=NP.ID_PRIVEZ 
LEFT OUTER JOIN KUPCI K ON K.ID = R.ID_LASTNIKA
LEFT OUTER JOIN PLOVILA P ON P.ID = R.ID_PLOVILA
WHERE R.STORNO IS NULL AND R.DATUM_DO IS NOT NULL
);

CREATE OR REPLACE VIEW V_REZERVAC_SVG AS (
SELECT DISTINCT V.ID, V.ID_REZERVAC_DETAIL, V.PRISOTNO, V.DATUM_REZERVACIJE, V.DATUM_DO, V.ID_LASTNIKA, V.ID_PLOVILA, V.ID_PRIVEZ, V.PRIIMEK AS PRIIMEK_LASTNIKA, V.IME AS IME_LASTNIKA, 
V.PLOVILO AS IME_PLOVILA, NVL(V.NTIP, 'J') AS TIP_PLOVILA, V.DOLZINA AS DOLZINA_PLOVILA, V.SIRINA AS SIRINA_PLOVILA, RD.TRANS_X AS TRANS_X_PLOVILA, RD.TRANS_Y AS TRANS_Y_PLOVILA, 
RD.ROT_DEGREES AS ROT_DEGREES_PLOVILA, NS.DOLZINA AS DOLZINA_PRIVEZA, NS.SIRINA AS SIRINA_PRIVEZA, NS.TRANS_X AS TRANS_X_PRIVEZA, NS.TRANS_Y AS TRANS_Y_PRIVEZA, NS.ROT_DEGREES AS ROT_DEGREES_PRIVEZA, N.OBJEKT,
V.VRSTA AS VRSTA_REZERVACIJE, V.STATUS_REZERVAC AS STATUS_REZERVACIJE
FROM V_REZERVAC V
JOIN NNPRIVEZ N ON N.ID_PRIVEZ = V.ID_PRIVEZ
JOIN NNPRIVEZ_SVG NS ON NS.ID_PRIVEZ = V.ID_PRIVEZ
LEFT JOIN REZERVAC_DETAIL_SVG RD ON RD.ID_REZERVAC_DETAIL = V.ID_REZERVAC_DETAIL
);

CREATE OR REPLACE VIEW V_NNPRIVEZ_REZERVAC AS (
SELECT DISTINCT NN.ID_PRIVEZ || '-' || VR.ID_REZERVAC_DETAIL AS ID, NN.ID_PRIVEZ, NN.OBJEKT, NN.KATEGORIJA, NN.N_PRIVEZA, NN.DOLZINA, NN.SIRINA, NN.VISINA, NN.GLOBINA, NN.LIMIT, NN.ZASEDENO,
VR.ID AS ID_REZERVAC, VR.ID_REZERVAC_DETAIL, VR.DATUM_REZERVACIJE, VR.DATUM_DO, VR.PRISOTNO, VR.PLOVILO AS IME_PLOVILA, VR.PRIIMEK AS PRIIMEK_LASTNIKA, VR.IME AS IME_LASTNIKA
FROM NNPRIVEZ NN
LEFT OUTER JOIN V_REZERVAC VR ON VR.ID_PRIVEZ = NN.ID_PRIVEZ
);


insert into verzije_baza (id, dt_vpis, verzija, ver_nr, opis) 
values 
(368, SYSDATE, '5.5', 288, 'Rezervacije');