CREATE OR REPLACE FORCE VIEW "V_TRANSACTIONS" ("Date", "Service_date", "Transaction", "Transaction_sif", "Value debit", "Value credit", "Membership No.", "Member", "Description", "ID_KUPCA", "ID_SALDKONT", "ID_RACUN_DATA", "ID_SALDKONT_ZAP", "ID_EXCHANGE", "ID_STORITVE", "ID_OBRACUN") AS 
  (select s.datum as "Date", 
  nvl(nvl(st.datum_do,st.datum_od),s.datum) as "Service Date",
case when r.id_obracun is not null then ob.opis
     else case when s.vrsta_racuna in ('POS', 'RAC') then n.interni_opis
               else nk.interni_opis
          end
end as "Transaction",
case when r.id_obracun is not null then 'ART'||art.id_artikel
     else case when s.vrsta_racuna in ('POS', 'RAC') then 'STO'||n.sifra
               else 'NKNJ'||nk.saldkont
          end
end as "Transaction_sif",
case when s.sdk_rn_pl = 'R' then
     case when s.vrsta_racuna in ('POS', 'RAC') then r.znesek
          else s.znesek
     end
else 0
end as "Value debit",
case when s.sdk_rn_pl = 'P' then
     case when s.vrsta_racuna in ('POS', 'RAC') then r.znesek
          else s.znesek
     end
else 0
end as "Value credit",
kp.id_member as "Membership No.", 
case when kp.ime is null then kp.priimek else kp.priimek || ', ' || kp.ime end as "Member",
case when s.vrsta_racuna in ('POS', 'RAC') then st.komentar
     else s.komentar
end as "Description",
kp.id as id_kupca,
s.id_saldkont as id_saldkont, 
r.id_racun_data as id_racun_data,
null as id_saldkont_zap,
null as id_exchange,
st.id_storitve as id_storitve,
ob.id_obracun as id_obracun
from saldkont s
left outer join racun_data r on (r.id_saldkont=s.id_saldkont)
left outer join m_storitve st on (r.id_storitve=st.id_storitve)
left outer join m_nnstomar n on (st.storitev=n.sifra)
join nknjizba nk on (s.vrsta_racuna=nk.saldkont) 
left outer join s_obracun ob on (r.id_obracun=ob.id_obracun)
left outer join s_artikli art on (ob.id_artikel=art.id_artikel)
left outer join kupci kp on (s.id_kupca=kp.id)
where s.vrsta_racuna <> 'RAZ'
and s.id_saldkont in (select id_saldkont from saldkont_izpisek_detail where id_kupca_org = s.id_kupca
                      and id_saldkont_izpisek not in (select id_saldkont_izpisek from saldkont_izpisek where complete='S'))
union all
select s.datum as "Date", s.datum as "Service Date",
case when ex.za_placilo <> 0 then nc.interni_opis
     else nk.interni_opis 
end as "Transaction",
case when ex.za_placilo <> 0 then 'CARD'||nc.id_cards
     else 'NKNJ'||nk.saldkont 
end as "Transaction_sif",
0 as "Value debit",
sz.znesek as "Value credit",
kp.id_member as "Membership No.", 
case when kp.ime is null then kp.priimek else kp.priimek || ', ' || kp.ime end as "Member",
case when ex.za_placilo <> 0 then m.n_kartice
     else s.komentar 
end as "Description",
kp.id as id_kupca,
s.id_saldkont as id_saldkont, 
null as id_racun_data,
sz.id_saldkont_zap as id_saldkont_zap,
ex.id as id_exchange,
null as id_storitve,
null as id_obracun
from saldkont_zap sz
join saldkont s on (s.id_saldkont=sz.id_saldkont)
join nknjizba nk on (s.vrsta_racuna=nk.saldkont) 
join exchange ex on (sz.id_exchange=ex.id)
left outer join money m on (sz.id_exchange=m.id_menjave)
left outer join kupci kp on (s.id_kupca=kp.id)
left outer join nncards nc on (m.id_cards=nc.id_cards)
where sz.id_pl_saldkont is null
and s.id_saldkont in (select id_saldkont from saldkont_izpisek_detail where id_kupca_org = s.id_kupca
                      and id_saldkont_izpisek not in (select id_saldkont_izpisek from saldkont_izpisek where complete='S'))
)
;
 

CREATE OR REPLACE FORCE VIEW "V_OPEN_TRANSACTIONS" ("Date", "Transaction", "Transaction_sif", "Value debit", "Value credit", "Membership No.", "Member", "Description", "ID_KUPCA", "ID_SALDKONT", "ID_RACUN_DATA", "ID_STORITVE", "ID_OBRACUN") AS 
  SELECT 
  nvl(a.datum_do,a.datum_od) as "Date",
  b.opis AS "Transaction",
  'STO' || a.storitev AS "Transaction_sif",
  a.znesek AS "Value debit",
  0 AS "Value Credit",
  c.id_member AS "MEmbership No.",
  CASE WHEN c.ime IS NULL THEN c.priimek ELSE c.priimek || ', ' || c.ime END AS "Member",
  a.komentar as "Description",
  c.id AS id_kupca,
  null AS id_saldkont, 
  null AS id_racun_data,
  a.id_storitve AS id_storitve,
  null as id_obracun
FROM m_storitve a
LEFT OUTER JOIN m_nnstomar b ON (a.storitev=b.sifra)
LEFT OUTER JOIN kupci c ON (a.id_lastnika=c.id)
WHERE a.n_racuna is null
AND a.vrsta <> 'DN' AND a.storitev <> (SELECT vrednost FROM s_nastavitve WHERE filter='MARINA' and sekcija='MARINA' and naziv = 'MemberUseService')--'STORE'
UNION ALL
SELECT 
  s.datum as "Date",
  nk.interni_opis AS "Transaction",
  'NKNJ' || nk.saldkont AS "Transaction_sif",
  CASE WHEN s.sdk_rn_pl = 'R' THEN s.znesek ELSE 0 END AS "Value debit",
  CASE WHEN s.sdk_rn_pl = 'P' THEN s.znesek ELSE 0 END AS "Value credit",
  kp.id_member as "Membership No.", 
  CASE WHEN kp.ime IS NULL THEN kp.priimek else kp.priimek || ', ' || kp.ime END AS "Member",
  s.komentar AS "Description",
  kp.id AS id_kupca,
  s.id_saldkont AS id_saldkont, 
  r.id_racun_data AS id_racun_data,
  null AS id_storitve,
  null AS id_obracun
FROM saldkont s
LEFT OUTER JOIN racun_data r ON (r.id_saldkont=s.id_saldkont)
JOIN nknjizba nk ON (s.vrsta_racuna=nk.saldkont) 
LEFT OUTER JOIN kupci kp ON (s.id_kupca=kp.id)
where s.vrsta_racuna NOT IN ('RAC', 'POS', 'AKA', 'AKM', 'REA', 'REM', 'RAZ')
and s.storno is null
and (not exists(select id_saldkont from saldkont_izpisek_detail where id_kupca_org = s.id_kupca
     and id_saldkont_izpisek not in (select id_saldkont_izpisek from saldkont_izpisek where complete='S')) 
     and s.zaprto=0)
UNION ALL
SELECT 
  s.datum as "Date",
  ob.opis AS "Transaction",
  'ART' || art.id_artikel AS "Transaction_sif",
  r.znesek AS "Value debit",
  0 AS "Value credit",
  kp.id_member as "Membership No.", 
  CASE WHEN kp.ime IS NULL THEN kp.priimek else kp.priimek || ', ' || kp.ime END AS "Member",
  s.komentar AS "Description",
  kp.id AS id_kupca,
  s.id_saldkont AS id_saldkont, 
  r.id_racun_data AS id_racun_data,
  null AS id_storitve,
  ob.id_obracun AS id_obracun
FROM saldkont s
LEFT OUTER JOIN racun_data r ON (r.id_saldkont=s.id_saldkont)
JOIN nknjizba nk ON (s.vrsta_racuna=nk.saldkont) 
LEFT OUTER JOIN s_obracun ob ON (r.id_obracun=ob.id_obracun)
LEFT OUTER JOIN s_artikli art ON (ob.id_artikel=art.id_artikel)
LEFT OUTER JOIN kupci kp ON (s.id_kupca=kp.id)
JOIN m_storitve m ON (s.id_saldkont=m.id_saldkont)
WHERE s.vrsta_racuna = 'RAZ'
AND m.n_racuna is NULL
;

CREATE OR REPLACE FORCE VIEW "V_STOR_MAT" ("ID_DN", "ID_RD_PROMET", "ID_ARTIKEL", "ID_STORITVE", "STORITEV", "KOLICINA", "POPUST", "ZNESEK", "DAVEK", "TECAJ", "ENOTA", "TIP_SERVIS", "N_RACUNA", "KOMENTAR", "ID_RAZNI_DOK") AS 
  SELECT A.ID_DN, B.ID_RD_PROMET, B.ID_ARTIKEL, 0 AS ID_STORITVE, NULL AS STORITEV, B.KOLICINA, B.RABAT AS POPUST,
B.CENA*B.KOLICINA AS ZNESEK, B.DAV_STOPNJA AS DAVEK, B.TECAJ, E.NAZIV, NULL AS TIP_SERVIS, NULL AS N_RACUNA, a.opomba AS KOMENTAR, a.id_razni_dok
FROM S_RAZNI_DOK A
JOIN S_RD_PROMET B ON A.ID_RAZNI_DOK=B.ID_RAZNI_DOK
LEFT OUTER JOIN S_ENOTE E ON E.ID_ENOTA=B.ENOTA
UNION
SELECT A.ID_DN, 0 AS ID_RD_PROMET, 0 AS ID_ARTIKEL, A.ID_STORITVE, A.STORITEV, A.KOLICINA*NVL(A.KOLICINA_INSTR,1) AS KOLICINA, NVL(A.POPUST,0),
A.ZNESEK, A.DAVEK, A.TECAJP, E.OPIS, A.TIP_SERVIS, A.N_RACUNA, A.KOMENTAR, 0 as id_razni_dok
FROM M_STORITVE A
JOIN M_NNSTOMAR B ON A.STORITEV=B.SIFRA
LEFT OUTER JOIN NNENOTE E ON E.SIFRA=B.ENOTA
AND (A.N_RACUNA<>'STORNO' OR A.N_RACUNA IS NULL)
;


insert into verzije_baza
(id, dt_vpis, verzija, ver_nr, opis) values (609, SYSDATE, '5.5', 529, 'View-i');
