INSERT INTO MARINA_SEQUENCES (TABLENAME, FIELDNAME, SEQUENCE_NAME, COUNTER_TYPE)
VALUES ('OPOMINI', 'ID_OPOMINI', 'OPOMINI_SEQ', 'S_KLJUCI');

CREATE OR REPLACE FORCE VIEW V_RACUN_PDV ("ID_RACUN", "ID_SALDKONT_FISC", "POREZ_STOPA", "OSNOVICA", "POREZ_IZNOS") AS 
SELECT ID_RACUN, ID_SALDKONT_FISC, POREZ_STOPA, SUM(OSNOVICA) AS OSNOVICA, SUM(POREZ_IZNOS) AS POREZ_IZNOS FROM
(
SELECT  SF.ID_SALDKONT AS ID_RACUN, SF.ID_SALDKONT_FISC, D.STOPNJA AS POREZ_STOPA, 
SUM(R.NETO) AS OSNOVICA, SUM(R.ZN_DAVKA*D.STOPNJA/R.DAV_STOPNJA) AS POREZ_IZNOS
FROM SALDKONT_FISC SF
JOIN RACUN_DATA R ON SF.ID_SALDKONT=R.ID_SALDKONT
LEFT OUTER JOIN M_STORITVE_DAVEK D ON R.ID_STORITVE=D.ID_STORITVE  AND D.VRSTA='DDV'
WHERE D.ID_STORITVE IS NOT NULL AND R.DAV_STOPNJA<>0
GROUP BY SF.ID_SALDKONT, SF.ID_SALDKONT_FISC, D.STOPNJA
union
SELECT SF.ID_SALDKONT AS ID_RACUN, SF.ID_SALDKONT_FISC, R.DAV_STOPNJA AS POREZ_STOPA, SUM(R.NETO) AS OSNOVICA, SUM(R.ZN_DAVKA) AS POREZ_IZNOS
FROM SALDKONT_FISC SF
JOIN RACUN_DATA R ON SF.ID_SALDKONT=R.ID_SALDKONT
LEFT OUTER JOIN M_STORITVE_DAVEK D ON R.ID_STORITVE=D.ID_STORITVE
WHERE ((D.ID_STORITVE IS NULL) OR (D.ID_STORITVE IS NOT NULL AND R.DAV_STOPNJA=0))
GROUP BY SF.ID_SALDKONT, SF.ID_SALDKONT_FISC, R.DAV_STOPNJA
union
SELECT SF.ID_SALDKONT AS ID_RACUN, SF.ID_SALDKONT_FISC, D.STOPNJA AS POREZ_STOPA, SUM((SZ.ZNESEK/SA.ZA_PLACILO)*(R.NETO)*(-1)) AS OSNOVICA, SUM((SZ.ZNESEK/SA.ZA_PLACILO)*(R.ZN_DAVKA*D.STOPNJA/R.DAV_STOPNJA)*(-1)) AS POREZ_IZNOS
FROM SALDKONT_FISC SF
JOIN SALDKONT_ZAP SZ ON SF.ID_SALDKONT=SZ.ID_SALDKONT
JOIN SALDKONT_FISC SFZ ON SZ.ID_SALDKONT_ZAP=SFZ.ID_SALDKONT_ZAP
JOIN SALDKONT SA ON SZ.ID_PL_SALDKONT=SA.ID_SALDKONT
JOIN RACUN_DATA R ON SA.ID_SALDKONT=R.ID_SALDKONT
LEFT OUTER JOIN M_STORITVE_DAVEK D ON R.ID_STORITVE=D.ID_STORITVE  AND D.VRSTA='DDV'
WHERE D.ID_STORITVE IS NOT NULL AND R.DAV_STOPNJA<>0
GROUP BY SF.ID_SALDKONT, SF.ID_SALDKONT_FISC, D.STOPNJA
union
SELECT SF.ID_SALDKONT AS ID_RACUN, SF.ID_SALDKONT_FISC, R.DAV_STOPNJA AS POREZ_STOPA, SUM(((SZ.ZNESEK/SA.ZA_PLACILO)*R.NETO)*(-1)) AS OSNOVICA, SUM((SZ.ZNESEK/SA.ZA_PLACILO)*R.ZN_DAVKA*(-1)) AS POREZ_IZNOS
FROM SALDKONT_FISC SF
JOIN SALDKONT_ZAP SZ ON SF.ID_SALDKONT=SZ.ID_SALDKONT
JOIN SALDKONT_FISC SFZ ON SZ.ID_SALDKONT_ZAP=SFZ.ID_SALDKONT_ZAP
JOIN SALDKONT SA ON SZ.ID_PL_SALDKONT=SA.ID_SALDKONT
JOIN RACUN_DATA R ON SA.ID_SALDKONT=R.ID_SALDKONT
LEFT OUTER JOIN M_STORITVE_DAVEK D ON R.ID_STORITVE=D.ID_STORITVE
WHERE ((D.ID_STORITVE IS NULL) OR (D.ID_STORITVE IS NOT NULL AND R.DAV_STOPNJA=0))
GROUP BY SF.ID_SALDKONT, SF.ID_SALDKONT_FISC, R.DAV_STOPNJA
) DDV
GROUP BY ID_RACUN, ID_SALDKONT_FISC, POREZ_STOPA
;

CREATE OR REPLACE FORCE VIEW V_RACUN_PNP ("ID_RACUN", "ID_SALDKONT_FISC", "POREZ_STOPA", "OSNOVICA", "POREZ_IZNOS") AS 
SELECT SA.ID_SALDKONT AS ID_RACUN, SF.ID_SALDKONT_FISC, D.STOPNJA AS POREZ_STOPA, SUM(R.NETO) AS OSNOVICA, SUM(R.ZN_DAVKA*D.STOPNJA/R.DAV_STOPNJA) AS POREZ_IZNOS
FROM SALDKONT_FISC SF
JOIN SALDKONT SA ON SF.ID_SALDKONT=SA.ID_SALDKONT
JOIN RACUN_DATA R ON SA.ID_SALDKONT=R.ID_SALDKONT
JOIN M_STORITVE S ON R.ID_STORITVE=S.ID_STORITVE
JOIN M_STORITVE_DAVEK D ON S.ID_STORITVE=D.ID_STORITVE
WHERE D.VRSTA='PNP'
GROUP BY SA.ID_SALDKONT, SF.ID_SALDKONT_FISC, D.STOPNJA
UNION
SELECT SF.ID_SALDKONT AS ID_RACUN, SF.ID_SALDKONT_FISC, D.STOPNJA AS POREZ_STOPA, SUM((SZ.ZNESEK/SA.ZA_PLACILO)*(R.NETO)*(-1)) AS OSNOVICA, SUM((SZ.ZNESEK/SA.ZA_PLACILO)*(R.ZN_DAVKA*D.STOPNJA/R.DAV_STOPNJA)*(-1)) AS POREZ_IZNOS
FROM SALDKONT_FISC SF
JOIN SALDKONT_ZAP SZ ON SF.ID_SALDKONT=SZ.ID_SALDKONT
JOIN SALDKONT_FISC SFZ ON SZ.ID_SALDKONT_ZAP=SFZ.ID_SALDKONT_ZAP
JOIN SALDKONT SA ON SZ.ID_PL_SALDKONT=SA.ID_SALDKONT
JOIN RACUN_DATA R ON SA.ID_SALDKONT=R.ID_SALDKONT
JOIN M_STORITVE S ON R.ID_STORITVE=S.ID_STORITVE
JOIN M_STORITVE_DAVEK D ON S.ID_STORITVE=D.ID_STORITVE
WHERE D.VRSTA='PNP'
GROUP BY SF.ID_SALDKONT, SF.ID_SALDKONT_FISC, D.STOPNJA
;

CREATE OR REPLACE FORCE VIEW V_RACUN_DDV ("ID_RACUN", "ID_SALDKONT_FISC", "STOPNJA_DDV", "OSNOVA", "DDV_ZNESEK") AS 
SELECT ID_RACUN, ID_SALDKONT_FISC, POREZ_STOPA AS STOPNJA_DDV, SUM(OSNOVICA) AS OSNOVA, SUM(POREZ_IZNOS) AS DDV_ZNESEK FROM
(
SELECT  SF.ID_SALDKONT AS ID_RACUN, SF.ID_SALDKONT_FISC, D.STOPNJA AS POREZ_STOPA, SUM(R.NETO*D.STOPNJA/R.DAV_STOPNJA) AS OSNOVICA, SUM(R.ZN_DAVKA*D.STOPNJA/R.DAV_STOPNJA) AS POREZ_IZNOS
FROM SALDKONT_FISC SF
JOIN RACUN_DATA R ON SF.ID_SALDKONT=R.ID_SALDKONT
LEFT OUTER JOIN M_STORITVE_DAVEK D ON R.ID_STORITVE=D.ID_STORITVE  AND D.VRSTA='DDV'
WHERE D.ID_STORITVE IS NOT NULL AND R.DAV_STOPNJA<>0
GROUP BY SF.ID_SALDKONT, SF.ID_SALDKONT_FISC, D.STOPNJA
union
SELECT SF.ID_SALDKONT AS ID_RACUN, SF.ID_SALDKONT_FISC, R.DAV_STOPNJA AS POREZ_STOPA, SUM(R.NETO) AS OSNOVICA, SUM(R.ZN_DAVKA) AS POREZ_IZNOS
FROM SALDKONT_FISC SF
JOIN RACUN_DATA R ON SF.ID_SALDKONT=R.ID_SALDKONT
LEFT OUTER JOIN M_STORITVE_DAVEK D ON R.ID_STORITVE=D.ID_STORITVE
WHERE ((D.ID_STORITVE IS NULL) OR (D.ID_STORITVE IS NOT NULL AND R.DAV_STOPNJA=0))
GROUP BY SF.ID_SALDKONT, SF.ID_SALDKONT_FISC, R.DAV_STOPNJA
union
SELECT SF.ID_SALDKONT AS ID_RACUN, SF.ID_SALDKONT_FISC, D.STOPNJA AS POREZ_STOPA, SUM((SZ.ZNESEK/SA.ZA_PLACILO)*(R.NETO*D.STOPNJA/R.DAV_STOPNJA)*(-1)) AS OSNOVICA, SUM((SZ.ZNESEK/SA.ZA_PLACILO)*(R.ZN_DAVKA*D.STOPNJA/R.DAV_STOPNJA)*(-1)) AS POREZ_IZNOS
FROM SALDKONT_FISC SF
JOIN SALDKONT SR ON SF.ID_SALDKONT=SR.ID_SALDKONT
JOIN SALDKONT_ZAP SZ ON SR.ID_SALDKONT=SZ.ID_SALDKONT
JOIN SALDKONT SA ON SZ.ID_PL_SALDKONT=SA.ID_SALDKONT
JOIN RACUN_DATA R ON SA.ID_SALDKONT=R.ID_SALDKONT
LEFT OUTER JOIN M_STORITVE_DAVEK D ON R.ID_STORITVE=D.ID_STORITVE  AND D.VRSTA='DDV'
WHERE D.ID_STORITVE IS NOT NULL AND R.DAV_STOPNJA<>0
GROUP BY SF.ID_SALDKONT, SF.ID_SALDKONT_FISC, D.STOPNJA
union
SELECT SF.ID_SALDKONT AS ID_RACUN, SF.ID_SALDKONT_FISC, R.DAV_STOPNJA AS POREZ_STOPA, SUM(((SZ.ZNESEK/SA.ZA_PLACILO)*R.NETO)*(-1)) AS OSNOVICA, SUM((SZ.ZNESEK/SA.ZA_PLACILO)*R.ZN_DAVKA*(-1)) AS POREZ_IZNOS
FROM SALDKONT_FISC SF
JOIN SALDKONT SR ON SF.ID_SALDKONT=SR.ID_SALDKONT
JOIN SALDKONT_ZAP SZ ON SR.ID_SALDKONT=SZ.ID_SALDKONT
JOIN SALDKONT SA ON SZ.ID_PL_SALDKONT=SA.ID_SALDKONT
JOIN RACUN_DATA R ON SA.ID_SALDKONT=R.ID_SALDKONT
LEFT OUTER JOIN M_STORITVE_DAVEK D ON R.ID_STORITVE=D.ID_STORITVE 
WHERE ((D.ID_STORITVE IS NULL) OR (D.ID_STORITVE IS NOT NULL AND R.DAV_STOPNJA=0))
GROUP BY SF.ID_SALDKONT, SF.ID_SALDKONT_FISC, R.DAV_STOPNJA
) DDV
GROUP BY ID_RACUN, ID_SALDKONT_FISC, POREZ_STOPA
;


insert into verzije_baza
(id, dt_vpis, verzija, ver_nr, opis) values (746, SYSDATE, '5.5', 666, 'Fiskalizacija');